# coding: utf-8

"""
    Gradient AI API

    Interface for interacting with Gradient AI.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, constr

class CreateModelRequestBodyModel(BaseModel):
    """
    CreateModelRequestBodyModel
    """
    base_model_id: constr(strict=True, min_length=1) = Field(..., alias="baseModelId", description="The foundational model you are creating a new instance of for fine-tuning.")
    name: constr(strict=True, min_length=1) = Field(..., description="What your new fine-tuned model will be called.")
    __properties = ["baseModelId", "name"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateModelRequestBodyModel:
        """Create an instance of CreateModelRequestBodyModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateModelRequestBodyModel:
        """Create an instance of CreateModelRequestBodyModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateModelRequestBodyModel.parse_obj(obj)

        _obj = CreateModelRequestBodyModel.parse_obj({
            "base_model_id": obj.get("baseModelId"),
            "name": obj.get("name")
        })
        return _obj

