# coding: utf-8

"""
    Gradient AI API

    Interface for interacting with Gradient AI.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, conint

class TrainModelSuccess(BaseModel):
    """
    TrainModelSuccess
    """
    number_of_trainable_tokens: conint(strict=True, ge=0) = Field(..., alias="numberOfTrainableTokens")
    sum_loss: Union[StrictFloat, StrictInt] = Field(..., alias="sumLoss")
    __properties = ["numberOfTrainableTokens", "sumLoss"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TrainModelSuccess:
        """Create an instance of TrainModelSuccess from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TrainModelSuccess:
        """Create an instance of TrainModelSuccess from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TrainModelSuccess.parse_obj(obj)

        _obj = TrainModelSuccess.parse_obj({
            "number_of_trainable_tokens": obj.get("numberOfTrainableTokens"),
            "sum_loss": obj.get("sumLoss")
        })
        return _obj

